#ifndef CGUL_RANDOM_LCG32_P_H
#define CGUL_RANDOM_LCG32_P_H

#include "cgul_common.h"
#include "cgul_random_lcg32.h"

CGUL_BEGIN_C

/**
 * Data encapsulated by the <code>cgul_random_lcg32</code> class.
 */
struct cgul_random_lcg32 {

    /**
     * The vector that holds PRNs that are waiting to be randomly selected.
     */
    cgul_uint32_t* v;

    /**
     * Index into v for the next PRN to be selected.
     */
    size_t v_index;

    /**
     * Current value for the first LCG.
     */
    cgul_uint32_t lcg1;

    /**
     * Current value for the second LCG.
     */
    cgul_uint32_t lcg2;

    /**
     * Current value for the third LCG.
     */
    cgul_uint32_t lcg3;

    /**
     * Current value for the fourth LCG.
     */
    cgul_uint32_t lcg4;

    /**
     * Current value for the Weyl Generator.
     */
    cgul_uint32_t weyl;

};

CGUL_END_C

#endif  /*  CGUL_RANDOM_LCG32_P_H  */
