#include <unistd.h>
#include <stdio.h>
#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 0;
    unsigned long result = 0;
    size_t rcount = 0;
    cgul_crc32_t crc32 = NULL;
    cgul_exception_t cex = NULL;
    unsigned char buf[16384];

#if 1
    crc32 = cgul_crc32__new_appends_size(&cex,
                                          0x04c11db7, 0,
                                          0xffffffff, 0, 0);
#else
    crc32 = cgul_crc32__new(&cex, 0xedb88320, 0xffffffff, 0xffffffff, 1);
#endif
    if (cex) {
        goto out;
    }

    for (;;) {
        rcount = read(STDIN_FILENO, buf, sizeof(buf));
        if (rcount <= 0) {
            break;
        }
        cgul_crc32__update_block(&cex, crc32, buf, rcount);
    }
    result = cgul_crc32__crc(&cex, crc32);
    cgul_libc__printf(&cex, "%lu  0x%lx\n", result, result);

 out:

    if (cex) {
        const char* msg = cgul_exception__get_message(cex);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(cex);
        cex = NULL;
        rv = 1;
    }

    if (crc32) {
        cgul_crc32__delete(crc32);
    }

    return rv;
}
