#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    unsigned long int i = 0;
    unsigned long int n = 0;
    const char* field = NULL;

    try {

        /* Open the CSV file. */
        cgul_csv_cxx csv("main_csv_tsv_input.tsv");

        /* Use the tab character as the separator. */
        csv.set_separator('\t');

        /* Iterate over each record. */
        while (csv.load_next()) {

            /* Test getting the field by the header for its column. */
            field = csv.lookup_by_header("header1");
            if (field) {
                cout << "field[\"header1\"] = " << field << endl;
            }

            /* Iterate over each field. */
            n = csv.get_number_of_fields();
            for (i = 0 ; i < n ; ++i) {
                field = csv.lookup(i);
                cout << "field[" << i << "] = " << field << endl;
            }
        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
