#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    char* ptr = NULL;
    size_t length = 0;
    unsigned long int cksum = 0;

    try {

        /* Verify command line. */
        if (argc != 2) {
            fprintf(stderr, "Usage: main_libc_load_file <file>\n");
            goto out;
        }

        /* Load the file into memory. */
        cgul_libc_cxx::load_fname(argv[1], &ptr, &length);

        /* Calculate and print the file's checksum. */
        cgul_crc32_cxx crc32(0x04c11db7, 0, 0xffffffff, 0, 0);
        cksum = crc32.crc_block(ptr, length);
        printf("%lu %lu %s\n", cksum, (unsigned long)length, argv[1]);

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;

    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

 out:
    
    /* Clean up. */
    if (ptr) {
        free(ptr);
    }

    return rv;
}
