#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

static int
remove_node_cb(cgul_list_cxx* l,
               cgul_list_node_cxx* n,
               void* data)
{
    void* value = NULL;
    l->remove_node(n, &value);
    free(value);
    return 1;
}

static int
print_node_cb(cgul_list_cxx* l,
              cgul_list_node_cxx* n,
              void* data)
{
    char* s = NULL;
    s = (char*)n->get_value();
    printf("%s\n", s);
    return 1;
}

int main(int argc, char* argv[])
{
    int rv = 0;
    int i = 0;
    char* tmp = NULL;

    try {    

        cgul_string_cxx s;
        cgul_list_cxx l;
        l.set_cache_size(10);

        for (i = 0 ; i < 10 ; ++i) {
            s.append_sprintf("%d", i);
            tmp = s.get_value();
            l.push_front((void*)tmp);
            s.take_value();
        }

        l.traverse(&print_node_cb, NULL);
        l.traverse(&remove_node_cb, NULL);

#if 0
        while (!l.is_empty()) {
            tmp = (char*)l.pop_front();
            cout << "tmp = " << tmp << endl;
            free(tmp);
        }
#endif

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
