#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    const char* fname = NULL;
    const char* boundary = NULL;

    try {

        /* Validate command line. */
        if (argc != 3) {
            cerr << "Usage: main_mime_split_file <file> <boundary>" << endl;
            rv = 1;
            goto out;
        }

        /* Set parameters from the command line. */
        fname = argv[1];
        boundary = argv[2];

        /*
         * NOTE: If you appear to be having trouble with cgul_mime, make
         * sure you are passing in the correct boundary string with the
         * leading "--" prefix that shows up in the MIME message removed.
         */

        /* Split the mime file. */
        cgul_mime_cxx::split_fname(fname,
                                   ".",
                                   "mime-preamble",
                                   "mime-header",
                                   "mime-body",
                                   "mime-epilogue",
                                   boundary,
                                   NULL);  /* auto eol */

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;

    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

 out:
    return rv;
}
