#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    size_t i = 0;
    cgul_string_t s = NULL;
    cgul_exception_t local = NULL;

    /* Allocate. */
    s = cgul_string__new(&local);
    if (local) {
        goto out;
    }

#if 0
    cgul_string__set_value(&local, s, "Hello, World!");
    if (local) {
        goto out;
    }
#endif

    /* Set the minimum capacity to 2 (one character plus NUL-terminator). */
    cgul_string__set_minimum_capacity(&local, s, 2);
    if (local) {
        goto out;
    }

    /* Create the string one character at a time.  Note that the final
     * string needs a capacity of (16 + 1) including the
     * NUL-terminator. */
    for (i = 0 ; i < 16 ; ++i) {

        /* Append the next character. */
        cgul_string__append_char(&local, s, 'z');
        if (local) {
            goto out;
        }

        /* Print the new value of the string. */
        printf("-->%s<--\n", cgul_string__get_value(&local, s));
    }

    /* Reduce the size of the string one character at a time. */
    for (i = cgul_string__get_length(&local, s) ; i > 0 ; --i) {

        /* Reduce the size of the string by one by removing the
         * trailing character. */
        cgul_string__set_length(&local, s, i - 1);

        /* Print the new value of the string. */
        printf("-->%s<--\n", cgul_string__get_value(&local, s));
    }

 out:

    /* Handle exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (s) {
        cgul_string__delete(s);
    }

    return rv;
}
