#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    const char* ptr = NULL;
    char* s1 = (char*)"Junk leading up to substring: Hello, World!";
    char* s2 = (char*)"Junk leading up to substring: Goodbye, Cruel World!";

    try {

        cgul_substring_cxx sub1 = "Hello";
        cgul_substring_cxx sub2;

        /*
         * EZ API
         */
        ptr = cgul_substring_cxx::search_ez("Hello", s1);
        if (ptr) {
            cout << "   EZ: " << ptr << endl;
        }

        ptr = cgul_substring_cxx::search_ez("Goodbye", 7, s2, strlen(s2));
        if (ptr) {
            cout << "   EZ: " << ptr << endl;
        }

        /*
         * Multiple Search API
         */
        ptr = sub1.search(s1);
        if (ptr) {
            cout << "Multi: " << ptr << endl;
        }

        sub2 = "Goodbye";
        ptr = sub2.search(s2);
        if (ptr) {
            cout << "Multi: " << ptr << endl;
        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;

    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
