#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

static int
print_value(void* value,
            void* data)
{
    printf("%d\n", *(int*)value);
    return 1;
}

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    int i = 0;
    int* value = NULL;
    cgul_vector_cxx v;

    try {

        /* Populate the list. */
        for (i = 0 ; i < 5 ; ++i) {
            /* Allocate a new value to add to the list. */
            value = (int*)malloc(sizeof(*value));
            if (!value) {
                throw runtime_error("out of memory");
            }
            /* Assign a value to the newly allocated memory. */
            *value = i;
            /* Add the value to the list. */
            v.push_back(value);
        }

        /* Print the values on the list in forward and then reverse order. */
        v.foldl(print_value, NULL);
        puts("====");
        v.foldr(print_value, NULL);

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    /* Clean up. */
    v.free_values();

    return rv;
}
